module 0-Logic where

open import Prelude

-- with the "variable" declaration, A, B, C are assumed to
-- be Set (type), if not declared otherwise.

variable
  A B C : Set

E0 : A → (A → B) → B
E0 = {!   !}

  -- Were it not for the variable declaration, we would have
  -- to enlist A, B, and C as arguments. 

E1 : (A : Set) → (B : Set) → (C : Set) → (A → B × C) → (A → B) × (A → C)
E1 A B C = {!   !}

 -- The type above can also be written as 
 --   (A : Set) (B : Set) (C : Set) → (A → B × C) → (A → B) × (A → C)
 --   (A B C : Set) → (A → B × C) → (A → B) × (A → C)
 -- The last case is more common.

 -- Arguments in curly brackets are implicit arguments
 -- This simulates polymorphic functions in, e.g, Haskell.

E1' : {A B C : Set} → (A → B × C) → (A → B) × (A → C)
E1' = {!   !}

E2 : {A B : Set} → (A ⊎ B) → (B ⊎ A)
E2 = {!   !}

E3 : {A B C : Set} → A × (B ⊎ C) → (A × B) ⊎ (A × C)
E3 = {!   !}

E4 : (A ⊎ B) × ¬ B → A
E4 = {!   !}

E5 : ¬ (((A → B) × (¬ A → C)) → (A × B) ⊎ (¬ A × C))
E5 = {!   !}

E6 : (((A × B) ⊎ (¬ A × C)) → ((A → B) × (¬ A → C)))
E6 = {!   !}



